local addonInfo, privateVars = ...

function nkRebuff.IconEdit (parent)

	local name = parent:GetName() .. '.iconEdit'

	local iconData = nil
	
	local key = nil
	local buffType = nil
	
	local iconEdit = UI.CreateFrame('Frame', name, parent)
	
	local content = UI.CreateFrame("Frame", name .. '.content', iconEdit)
	
	local hint = EnKai.uiCreateFrame('nkText', name .. '.hint', content)
	
	local useDefaultsCheckbox = EnKai.uiCreateFrame("nkCheckbox", name .. 'useDefaultsCheckbox', content)	
	
	local showIfActiveCheckbox = EnKai.uiCreateFrame("nkCheckbox", name .. 'showIfActiveCheckbox', content)	
	
	local showIfActiveHint = EnKai.uiCreateFrame('nkInfoText', name .. '.showIfActiveHint', content)
	
	local showLabelCheckbox = EnKai.uiCreateFrame("nkCheckbox", name .. 'showLabelCheckbox', content)	
	local showBorderCheckbox = EnKai.uiCreateFrame("nkCheckbox", name .. 'showBorderCheckbox', content)	
	local showTimerCheckbox = EnKai.uiCreateFrame("nkCheckbox", name .. 'showTimerCheckbox', content)
	local timerOutlineLabel = 	EnKai.uiCreateFrame("nkText", name .. 'timerOutlineLabel', content)
	local showStackCheckbox = EnKai.uiCreateFrame("nkCheckbox", name .. 'showStackCheckbox', content)	
	
	local labelColor = EnKai.uiCreateFrame("nkColorPicker", name .. '.labelColor', content)
	local borderColor = EnKai.uiCreateFrame("nkColorPicker", name .. '.borderColor', content)
	local timerColor = EnKai.uiCreateFrame("nkColorPicker", name .. '.timerColor', content)
	local timerOutlineColor = EnKai.uiCreateFrame("nkColorPicker", name .. '.timerOutlineColor', content)
	local stackColor = EnKai.uiCreateFrame("nkColorPicker", name .. '.stackColor', content)
	
	local sliderScale = EnKai.uiCreateFrame("nkSlider", name .. 'sliderScale', content)	
	local sliderwarnDurationLessThan = EnKai.uiCreateFrame("nkSlider", name .. '.warnDurationLessThan', content)	
	
	local editLabel = EnKai.uiCreateFrame("nkTextfield", name .. '.editLabel', content)	
	
	local selectTexture = EnKai.uiCreateFrame("nkImageGallery", name .. 'selectTexture', content)	
	
	local editXPos = EnKai.uiCreateFrame("nkTextfield", name .. 'editXPos', content)	
	local editYPos = EnKai.uiCreateFrame("nkTextfield", name .. 'editYPos', content)
	
	local slash = EnKai.uiCreateFrame('nkText', name ..'.slash', content)
	
	local moveUp = UI.CreateFrame('Texture', name ..'.moveUp', content)
	local moveDown = UI.CreateFrame('Texture', name ..'.moveDown', content)
	local moveLeft = UI.CreateFrame('Texture', name ..'.moveLeft', content)
	local moveRight = UI.CreateFrame('Texture', name ..'.moveRight', content)
	
	local updateButton = EnKai.uiCreateFrame('nkButtonMetro', name .. 'updateButton', content)
	local createButton = EnKai.uiCreateFrame('nkButtonMetro', name .. 'createButton', content)
	local deleteButton = EnKai.uiCreateFrame('nkButtonMetro', name .. 'deleteButton', content)
	
	--iconEdit:SetHeight(400)
	
	iconEdit:SetPoint("TOPRIGHT", parent, "TOPRIGHT")
	iconEdit:SetPoint("BOTTOMLEFT", parent, "BOTTOMRIGHT", -405, 0)
		
	content:SetPoint("TOPLEFT", iconEdit, "TOPLEFT")
	content:SetPoint("BOTTOMRIGHT", iconEdit, "BOTTOMRIGHT")
	content:SetLayer(2)
		
	hint:SetText(privateVars.langTexts.iconEditHint)
	hint:SetFontSize(16)
	hint:SetPoint("TOPCENTER", content, "TOPCENTER")

	showIfActiveCheckbox:SetPoint("TOPLEFT", iconEdit, "TOPLEFT", 0, 45)
	showIfActiveCheckbox:SetText(privateVars.langTexts.showIfActive)
	showIfActiveCheckbox:SetChecked(false)
	showIfActiveCheckbox:SetWidth(150)
	
	showIfActiveHint:SetPoint("TOPLEFT", showIfActiveCheckbox, "TOPRIGHT", 10, -5)
	showIfActiveHint:SetFontSize(10)
	showIfActiveHint:SetWidth(300)
	showIfActiveHint:SetHeight(50)
	showIfActiveHint:SetType('info')
	showIfActiveHint:SetIconAlign('top')
	showIfActiveHint:SetText(privateVars.langTexts.showIfActiveHint)
	
	useDefaultsCheckbox:SetPoint("TOPLEFT", showIfActiveCheckbox, "BOTTOMLEFT", 0, 12)
	useDefaultsCheckbox:SetText(privateVars.langTexts.useDefaults)
	useDefaultsCheckbox:SetChecked(true)
	useDefaultsCheckbox:SetWidth(150)
	
	Command.Event.Attach(EnKai.events[name .. 'useDefaultsCheckbox'].CheckboxChanged, function (_, newValue)		
		local flag
		if newValue == true then flag = false else flag = true end
			showLabelCheckbox:SetActive(flag)
			showBorderCheckbox:SetActive(flag)
			showTimerCheckbox:SetActive(flag)
			labelColor:SetActive(flag)
			borderColor:SetActive(flag)
			timerColor:SetActive(flag)
			timerOutlineColor:SetActive(flag)
			sliderScale:SetActive(flag)
			sliderwarnDurationLessThan:SetActive(flag)
	end, name .. 'useDefaultsCheckbox.CheckboxChanged')
	
	showLabelCheckbox:SetPoint("TOPLEFT", useDefaultsCheckbox, "BOTTOMLEFT", 0, 12)
	showLabelCheckbox:SetText(privateVars.langTexts.showLabel)
	showLabelCheckbox:SetChecked(true)
	showLabelCheckbox:SetWidth(150)
	showLabelCheckbox:SetActive(false)
	
	showBorderCheckbox:SetPoint("TOPLEFT", showLabelCheckbox, "BOTTOMLEFT", 0, 10)
	showBorderCheckbox:SetText(privateVars.langTexts.showBorder)
	showBorderCheckbox:SetChecked(true)
	showBorderCheckbox:SetWidth(150)
	showBorderCheckbox:SetActive(false)
	
	showTimerCheckbox:SetPoint("TOPLEFT", showBorderCheckbox, "BOTTOMLEFT", 0, 10)
	showTimerCheckbox:SetText(privateVars.langTexts.showTimer)
	showTimerCheckbox:SetChecked(true)
	showTimerCheckbox:SetWidth(150)
	showTimerCheckbox:SetActive(false)
	
	timerOutlineLabel:SetPoint("TOPLEFT", showTimerCheckbox, "BOTTOMLEFT", 0, 10)
	timerOutlineLabel:SetText(privateVars.langTexts.outline)
	
	showStackCheckbox:SetPoint("TOPLEFT", timerOutlineLabel, "BOTTOMLEFT", 0, 10)
	showStackCheckbox:SetText(privateVars.langTexts.showStack)
	showStackCheckbox:SetChecked(true)
	showStackCheckbox:SetWidth(150)
	
	labelColor:SetPoint("CENTERLEFT", showLabelCheckbox, "CENTERRIGHT", 20, 0 )
	labelColor:SetWidth(80)
	labelColor:SetHeight(15)
	labelColor:SetText(privateVars.langTexts.color)
	labelColor:SetColor(nkRBConfig.iconDefaults.labelColor[1], nkRBConfig.iconDefaults.labelColor[2], nkRBConfig.iconDefaults.labelColor[3], 1)
	labelColor:SetActive(false)
	labelColor:SetLayer(2)
	
	borderColor:SetPoint("CENTERLEFT", showBorderCheckbox, "CENTERRIGHT", 20, 0)
	borderColor:SetWidth(80)
	borderColor:SetHeight(15)
	borderColor:SetText(privateVars.langTexts.color)
	borderColor:SetColor(nkRBConfig.iconDefaults.borderColor[1], nkRBConfig.iconDefaults.borderColor[2], nkRBConfig.iconDefaults.borderColor[3], 1)
	borderColor:SetLayer(2)
	borderColor:SetActive(false)
	
	timerColor:SetPoint("CENTERLEFT", showTimerCheckbox, "CENTERRIGHT", 20, 0 )
	timerColor:SetWidth(80)
	timerColor:SetHeight(15)
	timerColor:SetText(privateVars.langTexts.color)
	timerColor:SetColor(nkRBConfig.iconDefaults.timerColor[1], nkRBConfig.iconDefaults.timerColor[2], nkRBConfig.iconDefaults.timerColor[3], 1)
	timerColor:SetLayer(2)
	timerColor:SetActive(false)
	
	timerOutlineColor:SetPoint("TOPLEFT", timerColor, "BOTTOMLEFT", 0, 5 )
	timerOutlineColor:SetWidth(80)
  timerOutlineColor:SetHeight(15)
  timerOutlineColor:SetText(privateVars.langTexts.color)
  timerOutlineColor:SetColor(nkRBConfig.iconDefaults.timerOutlineColor[1], nkRBConfig.iconDefaults.timerOutlineColor[2], nkRBConfig.iconDefaults.timerOutlineColor[3], 1)
  timerOutlineColor:SetLayer(2)
  timerOutlineColor:SetActive(false)
  
	stackColor:SetPoint("CENTERLEFT", showStackCheckbox, "CENTERRIGHT", 20, 0 )
	stackColor:SetWidth(80)
	stackColor:SetHeight(15)
	stackColor:SetText(privateVars.langTexts.color)
	stackColor:SetColor(nkRBConfig.iconDefaults.stackColor[1], nkRBConfig.iconDefaults.stackColor[2], nkRBConfig.iconDefaults.stackColor[3], 1)
	stackColor:SetLayer(2)
	
	sliderScale:SetPoint("TOPLEFT", showStackCheckbox, "BOTTOMLEFT", 0, 10)	
	sliderScale:SetRange(20, 150)
	sliderScale:AdjustValue(100)
	sliderScale:SetLabelWidth(136)
	sliderScale:SetWidth(236)
	sliderScale:SetText(privateVars.langTexts.scale)
	sliderScale:SetActive(false)
	
	sliderwarnDurationLessThan:SetPoint("TOPLEFT", sliderScale, "BOTTOMLEFT", 0, 10)	
	sliderwarnDurationLessThan:SetRange(0, 120)
	sliderwarnDurationLessThan:AdjustValue(20)
	sliderwarnDurationLessThan:SetLabelWidth(136)
	sliderwarnDurationLessThan:SetWidth(236)
	sliderwarnDurationLessThan:SetText(privateVars.langTexts.runOutWarning)
	sliderwarnDurationLessThan:SetActive(false)
	
	editLabel:SetPoint("TOPLEFT", sliderwarnDurationLessThan, "BOTTOMLEFT", 0, 20)
	editLabel:SetWidth(200)
	editLabel:SetHeight(22)
		
	selectTexture:SetPoint("TOPLEFT", editLabel, "BOTTOMLEFT", 0, 10)
	selectTexture:SetDefaultImages(true)
		
	moveLeft:SetPoint("CENTERLEFT", selectTexture, "CENTERRIGHT", 20, 0)
	moveLeft:SetTextureAsync('nkRebuff', 'gfx/arrowLeft.png')
	
	moveLeft:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconData.xpos = iconData.xpos - 1
		if iconData.xpos < 1 then iconData.xpos = 1 end
		iconEdit:UpdateIcon()
		editXPos:SetText(tostring(iconData.xpos))
	end, moveLeft:GetName() .. '.LeftClick')
	
	editXPos:SetPoint("CENTERLEFT", moveLeft, "CENTERRIGHT", 10 , 0)
	editXPos:SetWidth(50)
	
	slash:SetPoint("CENTERLEFT", editXPos, "CENTERRIGHT", 5 , 0)
	slash:SetText('/')
	
	editYPos:SetPoint("CENTERLEFT", slash, "CENTERRIGHT", 10 , 0)
	editYPos:SetWidth(50)
	
	moveRight:SetPoint("CENTERLEFT", editYPos, "CENTERRIGHT", 10, 0)
	moveRight:SetTextureAsync('nkRebuff', 'gfx/arrowRight.png')
	
	moveRight:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconData.xpos = iconData.xpos + 1
		iconEdit:UpdateIcon()
		editXPos:SetText(tostring(iconData.xpos))
	end, moveRight:GetName() .. '.LeftClick')
	
	moveUp:SetPoint ("CENTERBOTTOM", slash, "CENTERTOP", 0, -10)
	moveUp:SetTextureAsync('nkRebuff', 'gfx/arrowUp.png')
	
	moveUp:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconData.ypos = iconData.ypos - 1
		if iconData.ypos < 1 then iconData.ypos = 1 end
		iconEdit:UpdateIcon()
		editYPos:SetText(tostring(iconData.ypos))
	end, moveUp:GetName() .. '.LeftClick')
	
	moveDown:SetPoint ("CENTERTOP", slash, "CENTERBOTTOM", 0, 10)
	moveDown:SetTextureAsync('nkRebuff', 'gfx/arrowDown.png')
	
	moveDown:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconData.ypos = iconData.ypos + 1
		iconEdit:UpdateIcon()
		editYPos:SetText(tostring(iconData.ypos))
	end, moveDown:GetName() .. '.LeftClick')

	createButton:SetPoint("BOTTOMLEFT", content, "BOTTOMLEFT")
	createButton:SetText(privateVars.langTexts.create)
	createButton:SetWidth(150)
	createButton:SetScale(.8)
	
	createButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconEdit:CreateIcon()			
	end, createButton:GetName() .. ".LeftClick")	
	
	deleteButton:SetPoint("BOTTOMLEFT", content, "BOTTOMLEFT")
	deleteButton:SetText(privateVars.langTexts.delete)
	deleteButton:SetVisible(false)
	deleteButton:SetWidth(150)
  deleteButton:SetScale(.8)
	
	deleteButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconEdit:RemoveIcon()
	end, deleteButton:GetName() .. ".LeftClick")	
	
	updateButton:SetPoint("CENTERLEFT", deleteButton, "CENTERRIGHT", 10, 0)
	updateButton:SetText(privateVars.langTexts.update)
	updateButton:SetVisible(false)
	updateButton:SetWidth(150)
  updateButton:SetScale(.8)
	
	updateButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		iconEdit:ReadConfig()
		iconEdit:UpdateIcon()
	end, updateButton:GetName() .. ".LeftClick")	
	
	function iconEdit:CreateIcon()
		iconEdit:ReadConfig()		
		
		if privateVars.uiElements.icons[buffType][key] == nil then 
			privateVars.uiElements.icons[buffType][key] = nkRebuff.createIcon (buffType, key, iconData) 
			privateVars.uiElements.icons[buffType][key]:SetDragable(true)			
		else 
			privateVars.uiElements.icons[buffType][key]:SetVisible(true) 
			iconEdit:UpdateIcon()
		end
				
		nkRBIcons[nkRBConfig.activeSet][buffType][key] = EnKai.tools.table.copy(iconData)
		
		Command.Event.Detach(privateVars.events["nkRebuffIcon." .. buffType .. '.' .. key].Moved, nil, "nkRebuffIcon." .. buffType .. '.' .. key .. '.Moved')
		
		Command.Event.Attach(privateVars.events["nkRebuffIcon." .. buffType .. '.' .. key].Moved, function (_, newValue)		
			if createButton:GetVisible() == false then
				iconData.xpos = math.floor(privateVars.uiElements.icons[buffType][key]:GetLeft())
				iconData.ypos = math.floor(privateVars.uiElements.icons[buffType][key]:GetTop())
				iconEdit:SetConfig()
			end
		end, "nkRebuffIcon." .. buffType .. '.' .. key .. '.Moved')
			
		deleteButton:SetVisible(true)
		updateButton:SetVisible(true)
		createButton:SetVisible(false)
	end
	
	function iconEdit:ReadConfig()
	
		iconData = EnKai.tools.table.copy(nkRBConfig.iconDefaults)
		
		iconData.showIfActive = showIfActiveCheckbox:GetChecked()
		
		iconData.useDefaults = useDefaultsCheckbox:GetChecked()
				
		if useDefaultsCheckbox:GetChecked() == false then
			iconData.showLabel = showLabelCheckbox:GetChecked()
			iconData.showBorder = showBorderCheckbox:GetChecked()
			iconData.showTimer = showTimerCheckbox:GetChecked()
			iconData.labelColor = { labelColor:GetColor() }
			iconData.borderColor = {  borderColor:GetColor() }
			iconData.timerColor = {  timerColor:GetColor() }
			iconData.timerOutlineColor = { timerOutlineColor:GetColor() }
			iconData.stackColor =  {  stackColor:GetColor() }
			iconData.scale = sliderScale:GetValue('value')
			iconData.warnDurationLessThan = sliderwarnDurationLessThan:GetValue('value')
		end

		iconData.showStack = showStackCheckbox:GetChecked()
		iconData.label = editLabel:GetText()
		iconData.textureType = selectTexture:GetImage(selectTexture:GetImagePos()).textureType
		iconData.texturePath = selectTexture:GetImage(selectTexture:GetImagePos()).texturePath
		iconData.xpos = tonumber(editXPos:GetText())
		iconData.ypos = tonumber(editYPos:GetText())
		
	end
	
	function iconEdit:UpdateIcon()
	
		if privateVars.uiElements.icons[buffType][key] == nil then return end
		
		local icon = privateVars.uiElements.icons[buffType][key]
	
		icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", iconData.xpos, iconData.ypos)
		icon:SetTexture(iconData.textureType, iconData.texturePath)
		icon:ShowLabel(iconData.showLabel)
		icon:ShowBorder(iconData.showBorder)
		icon:ShowTimer(iconData.showTimer)
		icon:ShowStack(iconData.showStack)
		
		icon:SetScale(iconData.scale / 100)
		
		icon:SetBorderColor (iconData.borderColor[1], iconData.borderColor[2], iconData.borderColor[3], iconData.borderColor[4])
		icon:SetLabelColor (iconData.labelColor[1], iconData.labelColor[2], iconData.labelColor[3], iconData.labelColor[4])
		icon:SetTimerColor (iconData.timerColor[1], iconData.timerColor[2], iconData.timerColor[3], iconData.timerColor[4],
		                    iconData.timerOutlineColor[1], iconData.timerOutlineColor[2], iconData.timerOutlineColor[3])
		icon:SetStackColor (iconData.stackColor[1], iconData.stackColor[2], iconData.stackColor[3], iconData.stackColor[4])
		
		icon:SetLabel(nkRebuff.ComputeLabel(iconData.label))
		nkRBIcons[nkRBConfig.activeSet][buffType][key] = EnKai.tools.table.copy(iconData)
			
	end
	
	function iconEdit:RemoveIcon()

		if iconData == nil then return end -- check if iconData is not set / done to prevent a reported error I was not able to replicate
	
		if privateVars.uiElements.icons[buffType][key] ~= nil then 
		
			privateVars.uiElements.icons[buffType][key]:SetVisible(false)
			--icon = nil		
			--privateVars.uiElements.icons[buffType][key] = nil
			nkRBIcons[nkRBConfig.activeSet][buffType][key] = nil
			
			local tempIconData = EnKai.tools.table.copy(nkRBConfig.iconDefaults)
			tempIconData.label = iconData.label
			tempIconData.texturePath = iconData.texturePath
			tempIconData.textureType = iconData.textureType
			
			iconEdit:SetConfig(tempIconData)
		end
		
		createButton:SetVisible(true)
		deleteButton:SetVisible(false)
		updateButton:SetVisible(false)		
		
	end

	function iconEdit:SetImage(textureType, texturePath)
		selectTexture:AddImages({{ textureType = textureType, texturePath = texturePath }}, false )
		local pos = selectTexture:FindImagePos (textureType, texturePath)
		selectTexture:SetImagePos(pos)		
	end
	
	function iconEdit:SetIcon()
				
		privateVars.uiElements.icons[buffType][key]:SetDragable(true)
		
		createButton:SetVisible(false)
		deleteButton:SetVisible(true)
		updateButton:SetVisible(true)
		
		Command.Event.Detach(privateVars.events["nkRebuffIcon." .. buffType .. '.' .. key].Moved, nil, "nkRebuffIcon." .. buffType .. '.' .. key .. '.Moved')
		
		Command.Event.Attach(privateVars.events["nkRebuffIcon." .. buffType .. '.' .. key].Moved, function (_, newValue)
			if createButton:GetVisible() == false then			
				iconData.xpos = math.floor(privateVars.uiElements.icons[buffType][key]:GetLeft())
				iconData.ypos = math.floor(privateVars.uiElements.icons[buffType][key]:GetTop())
				iconEdit:SetConfig()
			end
		end, "nkRebuffIcon." .. buffType .. '.' .. key .. '.Moved')
	end
	
	function iconEdit:SetConfig(newIconData)
		
		if newIconData ~= nil then iconData = newIconData end
		
		if buffType == 'cooldownsPlayer' then
			showIfActiveCheckbox:SetActive(false)
		else
			showIfActiveCheckbox:SetActive(true)
		end
		
		showIfActiveCheckbox:SetChecked(iconData.showIfActive)
		
		useDefaultsCheckbox:SetChecked(iconData.useDefaults)
		showLabelCheckbox:SetChecked(iconData.showLabel)
		showBorderCheckbox:SetChecked(iconData.showBorder)
		showTimerCheckbox:SetChecked(iconData.showTimer)
		showStackCheckbox:SetChecked(iconData.showStack)
		
		labelColor:SetColor(iconData.labelColor[1], iconData.labelColor[2], iconData.labelColor[3], iconData.labelColor[4])
		borderColor:SetColor(iconData.borderColor[1], iconData.borderColor[2], iconData.borderColor[3], iconData.borderColor[4])
		timerColor:SetColor(iconData.timerColor[1], iconData.timerColor[2], iconData.timerColor[3], iconData.timerColor[4])
		timerOutlineColor:SetColor(iconData.timerColor[1], iconData.timerColor[2], iconData.timerColor[3], 1)
		stackColor:SetColor(iconData.stackColor[1], iconData.stackColor[2], iconData.stackColor[3], iconData.stackColor[4])
		
		sliderScale:AdjustValue(iconData.scale)
		sliderwarnDurationLessThan:AdjustValue(iconData.warnDurationLessThan)
		
		editLabel:SetText(iconData.label)
		
		iconEdit:SetImage (iconData.textureType, iconData.texturePath)
		
		editXPos:SetText(tostring(math.floor(iconData.xpos)))
		editYPos:SetText(tostring(math.floor(iconData.ypos)))
			
	end
	
	function iconEdit:Update()
		-- updates configuration values
		selectTexture:SetDefaultImages(true)
	end
	
	function iconEdit:SetKey(newKey) key = newKey end
	function iconEdit:SetBuffType(newBuffType) buffType = newBuffType end
		
	return iconEdit	
	
end
