local addonInfo, privateVars = ...

if EnKai.tools.lang.getLanguage() ~= "German" then
	
	privateVars.langTexts = {
	 btClose        = "close",
		txtVersion				= 'Version %s',
		
		msgNewItemVersion		= 'nkRebuff: New version of <font color="#0094FF">%s</font> found. Updating config!',
		msgActivateSetInCombat  = "nkRebuff: <font color='#FF0000'>Player is in fight!</font> Set will not be changed.",
		tabHeaderSettings		= 'Settings',
		tabHeaderIconDefaults	= "Icon defaults",
		tabHeaderTracking		= 'Abilities',
		tabHeaderExchange		= 'Import/Export',
		tabHeaderManual			= 'Manual',
		manualHeader			= 'nkRebuff manual',
		
		exportButton			= 'Export set',
		importButton			= 'Import set',
		importErrorChecksum		= 'The import failed (checksum)! The text is not matching what was exported!',
		importErrorFormat		= 'The import failed due to an incorrect data format!',
		exportHint				= 'After doing the export please click into the field and do CTRL+A and CTRL+C. Afterwards hit ESC to leave the field.\nTo import simply paste the export code into this field and click the import button.',
		
		buffButtonHintHeader	= 'Rebuff button',
		buffButtonHintDesc		= 'Click the button to activate missing buffs. One buff will be activated per click.\n\nNext action:\n<font color="#FFD800">%s</font>',
		
		headerDescription		= 'Description',
		design					= 'Design',
		showLabel				= 'Show label',
		showBorder				= 'Show border',
		showTimer				= 'Show timer',
		showStack				= 'Show stack',
		scale					= 'Scale %d%%',
		functionality			= 'Functionality',
		runOutWarning			= '%d sec warning',
		color					= 'Color',
		outline       = 'Outline',
		trackGridHint			= 'Left click to edit / right click to activate or deactivate',
		update					= 'Update',
		useDefaults				= "Use defaults",
		showIfActive			= "Show if active",
		showIfActiveHint		= "Icon is shown if\nDeactivated: Buff/Debuff is <font color='#FF0000'>missing</font>\nActivated: Buff/Debuff is <font color='#FF0000'>applied</font>",
		create					= 'Create',
		delete					= 'Delete',
		abilityType				= 'Type',
		duration				= 'Duration',
		durationValue			= '%d sec',
		castBy					= 'Cast by',
		storeThis				= 'Store this',
		analyze					= 'Analyse',
		storeSelected			= 'Store selected',
		analyzeHint				= "(1) Cast ability\n(2) Left click line of ability to store => Store this cell become green\n(3) Click on button",
		shortLabels				= "Short labels",
		labelGlobal				= "Global settings",
		effect					= "icon effect",
		effectSelection			= {{ label = "- deactivated - ", value = 'none', }, { label = 'Glossy', value = 'gloss' }, { label = 'Round', value = 'round'}, { label = 'Basic', value = 'basic' }, { label = 'Chrome', value = 'chrome' },
									{ label = "Rounded corners", value = 'roundedCorners'} },
		stackHint				= "The color is a global setting for all icons using the default. Whether an icon displays the stack has to be set individually per icon!",
		iconEditHint			= "Icon definition",
		removeAbility			= "Remove ability",
		
		colorSelection = {{label = "Black", value = 'black' }, {label = "White", value = 'white'}, { label = "Red", value = 'red'}, { label = "Yellow", value = 'yellow'}, { label = "Blue", value = 'blue'}},
		
		settingSelection = {	{ value = 'buffsPlayer', label = "Buffs on player"},  { value = 'buffsPet', label = 'buffs on pet'}, { value = 'debuffsTarget', label = "Debuffs on target"}, { value = 'cooldownsPlayer', label = "Cooldowns"} },
		selSetting 			 = 'Ability',
		
		genericSettings = {
			basic			= 'Basic settings',
			performance		= 'Performance',
			sets 			= 'Sets',
			setsHint		= 'Please first manually switch the role and then the set. Otherwise pictures\nof new abilities are not available for selection in the config!',
			
			active			= 'Addon activated',
			usePluginCheckbox	= 'Use plugin',
			throttleSlider		= 'Update interval %.1f sec',
			roleSwitch 		= 'Recognize role swith',
			currentSet 		= 'Current set',
			debuffWarningCheckbox = "Player debuff warning",
			checkForUpdatesCheckbox = 'Check for updates',
			showTooltipsCheckbox	= 'Show tooltips',
			
			addButton		= 'Add',
			newSetName		= 'New set %d',
			copiedSetName	= 'Copy of %s',
			removeButton	= 'Delete',
			copySetButton	= 'Copy',
			role			= 'assigned role',
			
			cbCombat		= "Show only in combat",
			selectionRole 	= {{ label = 'deactivated', value = 0 } },
			roleLabel		= "Role %d",
			
			buffButton		= "ReBuff Button",
			showButton		= "Show button",
			bbDisplay		= {{ label = "- deactivated -", value = '0'}, { label = "always", value = "always"}, { label = "if rebuff is needed", value = "rebuff"}, { label = "show bar", value = "bar"}},
			bbHint			= "Clicking the ReBuff button you can automatically apply missing buffs.\n<font color='#FF0000'>Only works out of combat!</font>\nRight click and drag while in config to move the button on the screen."
		},
		
		messages = {
			dialogTitle			= 'Error message',
			cannotRemoveLastSet = 'You cannot delete the last set!',
			removeCurrentSet	= 'Are you sure you want to delete the set?',
			createIcons			= 'Do you want to create icons for the selected abilities?',
			importDuplicateSet	= 'A set with the name %s already exists!\nDo you want to overwrite the existing set?',
		},
	
		various = {
			buttonMenuConfig	= "Configuration",
			buttonMenuManual	= "Manual",
			msgLoaded			= "%s %s loaded",
			version				= "Version",
			commandSetRefuse 	= 'Invalid set! valid values are 1 - %d',
			activateSet			= 'Activating set %s',
		},
		
		player	= 'Player',
		pet		= 'Pet',
		npc		= 'NPC',
		debuff	= 'Debuff',
		buff	= 'Buff',
		buffOnPet = 'Buff on pet',
		cooldown= 'Cooldown',
		curse	= 'Curse',

		errTypeConfig 		= "nkRebuff Error - Configuration",
		errMissingBuffData	= "No stored info for <font color='#0094FF'>%s</font>. Please re-perform analyse."
	}
	
end